# nanakochi123456 version nyatakasan/hiratara 1st release:mnakajim

BEGIN {
	my $conv_start = (times)[0];
	require "fatlib.pl";
}

use utf8;
use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use Encode qw/decode decode_utf8/;
use Encode::Guess;
use PlannedBlackoutJP::Util qw/is_galapagos/;
use Text::MicroTemplate::File;
use Nana::Cache;
use HTTP::Lite;
require "common.pl";

my $tokyodenryoku_base_url="http://www.tepco.co.jp/forecast/html/images/juyo-j.csv";
my $cachefile="denryokuusage";
my $debug;

print "Content-type:text/plain\n\ntest";
exit;

&main;

sub main {
	my $mobileflg;
	my $mflg=0;
	$mobileflg=1 if(is_galapagos(\%ENV) || $mflg);

#	my $cache=new Nana::Cache (
#		ext=>"csv",
#		files=>10,
#		dir=>"./cache",
#		size=>100000,
#		use=>1,
#		expire=>30*60,#３０分
#	);
#
#	my $http_body=$cache->read($cachefile,1);
#	if($http_body ne '') {
#		my $status;
#		($status,$http_body)=&httpcl($tokyodenryoku_base_url);
#		if($status eq 0) {
#			$cache->write($cachefile,$http_body);
#		}
#	}
		($status,$http_body)=&httpcl($tokyodenryoku_base_url);

print <<EOM;
Content-type: text/plain

$http_body
EOM
exit;
	#  UPDATE  文字 供給力    改行 文字 供給      改行 文字
	$http_body=~s/\x0D\x0A|\x0D|\x0A/\x0A/g;
	my @pwtmp=split(/\n/,$http_body);
	my $update=$pwtmp[0];
	my $kyoukyuu=$pwtmp[2];
	my $maxpower=$pwtmp[5];
	my @pw;
	for(my $i=0; $i<24; $i++) {
		$pw[$i]=$pwtmp[$i+8];
	}
		
	my($update_date,$update_time,$tmp)=split(/ /,$update);
	my $update_str="$update_date $update_time";
	my($kyoukyuu_kw,$kyoukyuu_time,$kyoukyuu_date,$kyoukyuu_update_time)
		=split(/,/,$kyoukyuu);
	$maxpower=~s/～/-/g;
	my($maxpower_kw,$maxpower_time,$maxpower_date,$maxpower_update_time)
		=split(/,/,$maxpower);
	my @hour_refs;
	for(my $i=0; $i<24; $i++) {
		#  日付
		my($tmp,$pw_date,$pw_time,$today_power,$yesterday_power)
			=split(/,/,$pw[$i]);
		my $persent=int($today_power / $maxpower_kw);
		push @hour_refs,  {
			time => $pw_time,
			today_power => $today_power,
			yesterday_power => $yesterday_power,
			persent => $persent,
		};
	}
	&gzip_compress("Content-type: text/html; charset=utf-8\nCache-Control: max-age=0\nExpires: Mon, 26, Jul 1997 05:00:00 GMT");
	my $mtf = Text::MicroTemplate::File->new;
	my $template="powerusage_jp.html";
	my $html = $mtf->render_file(
		$template,
		"$update_date $update_time",
		$kyoukyuu_kw,$kyoukyuu_time,
		$maxpower_kw,$maxpower_time,
		\@hour_refs);

	if($mobileflg) {
		$html=&z2h($html);
	}

	print <<EOM;
<?xml version="1.0" encoding="UTF-8" ?>
$html$debug
EOM
	}

sub httpcl {
	my ($url)=shift;
	my $http=new HTTP::Lite;
	$http->method("GET");
	$http->http11_mode(1);
	my $req=$http->request($url);
	if($req eq 200) {
		return(0,$http->body());
	} else {
		return(1,"Error $req");
	}
}
